# Contributions Guide

Thank you for your interest in contributing to **WiFi AutoLogin**! We welcome contributions of all kinds, including bug fixes, feature enhancements, documentation improvements, and translations.

## How to Contribute

### 1. Fork the Repository

1. Navigate to the [ACT GitHub repository](https://github.com/arjunmnath/ACTx).
2. Click the **Fork** button to create a copy in your own GitHub account.

### 2. Clone the Repository

```sh
git clone https://github.com/arjunmnath/ACTx.git
cd ACTx
```

### 3. Create a Feature Branch

```sh
git checkout -b feature-name
```

### 4. Make Your Changes

- Ensure your code follows the project's coding style.
- Test your changes on all supported platforms if applicable.

### 5. Commit and Push

```sh
git add .
git commit -m "Describe your changes"
git push origin feature-name
```

### 6. Open a Pull Request

1. Go to the original repository on GitHub.
2. Click **Pull Requests** > **New Pull Request**.
3. Select your branch and submit your changes for review.

## Contribution Guidelines

- Follow the **coding style** used in the repository.
- Write **clear commit messages**.
- Keep pull requests **focused** on a single feature or bug fix.
- Ensure changes are **well-tested** before submission.

## Reporting Issues

If you encounter bugs or have feature suggestions, please open an issue:

1. Go to the [Issues](https://github.com/arjunmnath/ACTx/issues) tab.
2. Click **New Issue** and provide a detailed description.

## Code of Conduct

By contributing, you agree to follow our [Code of Conduct](CODE_OF_CONDUCT.md) to ensure a welcoming environment for all.

## Acknowledgments

We appreciate your contributions! Feel free to reach out with any questions or suggestions.

Happy coding! 🚀
